
// C Y M P L A Y                                                            
// ~~~~~~~~~~~~~                                                            
//                                                                          
// History :-                                                               
//                                                                          
// v0.7JB (20/Jan/99)  -    This "Jarek Burczynski" version now uses the
// ------------------       v2.0 (Sept 1998) emulation core! - this is also
//                          now stereo and optimized, like Satoh's.
//                          This emulation is from MAME 0.35b1.
//                          EXE now compressed with UPX!
//
// v0.3J (05/Jan/99)   -    Channel 0 panned hard-left (-100)
// -----------------        Channel 1 panned hard-right (100)
//                          Even though Jarek's engine is mono.
//                          Volume levels fixed to 100 (max)
//                          Shuts down sound output correctly
//                          This version uses Jarek's engine and is
//                          mainly for compatibility sakes and testing.
//                          [-loop] added to loop choon ;)
//                          Now using SEAL v1.06! Master Mixer Volume Levels
//                          at last!! Much louder now!!
//                          Volume of the streams set to 20 - any more causes 
//                          it to be too loud I think :)
//
// v0.21 (18/Dec/98)   -    Yes, two updates in one code-sesh ;)
// -----------------        Got rid of Allegro totally (EXE now half-size!) 
//                          Rewritten some comments ;)                      
//                                                                          
// v0.2  (18/Dec/98)   -    A minor update to this DOS version; Fixed the   
// -----------------        seg fault in pure-dos.. it was due to not       
//                          malloc'ing my sound buffer to init it! :) nutz! 
//                          I can't believe I missed that!! Thanks to       
//                          Chipmunk who told me! & check out his Win32 ver!
//                                                                          
// v0.1  (13/Dec/98)   -    Plays the CYM file back fine. Is extremely slow 
// -----------------        however! It needs at least a P233MMX to play the
//                          sound properly (no scratching, full-speed).     
//                          Audio streams working OK, I think. (Seal rulez!)
//                          Emulation working great, no probs! (MAME yeah!) 

#include <stdlib.h>
#include <stdio.h>
#include <conio.h>
#include <fcntl.h>

#include "sound.c"                          // OSD_audio_streams (MAME 0.34b8)
#include "ym2151.c"                         // YM2151 emulator (MAME 0.35b1)

static SAMP *ym2151_buffer[2];              // this is where the sound data will be put
                                            // this SAMP structure is whats used in Jarek's
                                            // code.
                                            // its a TYPEDEF VOID structure.
                                            // see in ym2151.h for more info.
                                            //
                                            // [0] = left channel  \_ stereo
                                            // [1] = right channel /

int data_sample_rate = 44100;               // hard-coded for now, well, 44Khz is best anyways ;-)

int throttle = 1;                           // throttle , auto-frame-skip?

                                            // 0 = left  \_ YM2151 sound output
int channel = 0;                            // 1 = right /  (no, its not stereo, i just want more volume)

int cym_file_handle = -1;
unsigned char *cym_data = NULL;             // file data loaded into this

int main(int argc, char *argv[])
{   
    long cym_file_length = 0;
    long cym_data_pos = 0;
    int cym_YM2151_register = 0;
    int cym_YM2151_value = 0;
    int buffer_size = 800;                  // sample_rate/fps suposedly
    int loop = 0;
    int hitkey = 0;                         // 27 = ESC
    int loopflag = 0;                       // 1 = looping, 0 = play once only

    // allocate the memory for the buffers
    ym2151_buffer[0] = malloc(buffer_size * 2);
    ym2151_buffer[1] = malloc(buffer_size * 2);

    // set the mem to conains zeros
    memset(ym2151_buffer[0], 0, buffer_size * 2);
    memset(ym2151_buffer[1], 0, buffer_size * 2);

    if (argc == 1)
    {
        printf("\n CYMPLAY v0.7JB! (C)Starshine! [Build : 29th January 1999]\n");
        printf("\n YM2151 Emulation, v2.0, September 1998 (C)Jarek Burczynski\n");
        printf("\n Use : CYMPLAY <.CYM file> [-loop]\n");
        exit(0);
    }
    
    // check for "-loop" argument for looping
    if (argc == 3 && strcmp("-loop", argv[2]) == 0)
    {
        loopflag = 1;
    }

    // initialize Seal and the sound hardware
    msdos_init_seal();
    msdos_init_sound();

    // little messages
    printf(" # CYMPLAY v0.7JB! (C)Starshine!\n");    
    printf(" # SEAL Audio Library v1.06 Initialized!\n");    
    
    ///////////////////////////////////////////////////////////////
    // Load the CYM file into memory
    ///////////////////////////////////////////////////////////////
    
    cym_file_handle = _open(argv[1], _O_RDONLY | _O_BINARY);
    if (cym_file_handle == -1)
    {
        //allegro_exit();
        printf("\n ERROR:\tFILE DOES NOT EXIST!\n");
        exit(0);
    }
    cym_file_length = filelength(cym_file_handle);
    cym_data = malloc(cym_file_length);    
    _read(cym_file_handle, cym_data, cym_file_length);
    _close(cym_file_handle);

    printf(" # CYM File Loaded!\n");

    if (loopflag == 1)
    {
        printf(" # LOOP PLAYBACK Activated!\n");
    }
    
    ///////////////////////////////////////////////////////////////
    // Initialize the YM2151 (JB, v2.0)
    ///////////////////////////////////////////////////////////////
        
    // YM2151Init(int num, int clock, int rate,int sample_bits )
    YM2151Init(1, (double)3579580, data_sample_rate, 16);
    printf(" # YM2151 (JB, v2.0) Initialized & Ready!\n");
    
    printf(" # Playing! - Press Any Key To Quit!\n");
    
    ///////////////////////////////////////////////////////////////
    
    while (cym_data_pos < cym_file_length && hitkey != 27)
    {        
        // 0x00 // VBLANK // UPDATE //
        if (cym_data[cym_data_pos] == 0x00)
        {
                // YM2151UpdateOne(int num, SAMP **buffers, int length)
                YM2151UpdateOne(0, ym2151_buffer, buffer_size);
                
                // channel   = 0 = left
                // channel+1 = 1 = right
                                
                // TWO 16-bit audio streams, one for each speaker
                // osd_play_streamed_sample_16(channel, (signed short *)buffer, size, rate, vol, pan)
                // [pan] range is 0 (left) to 255 (right)
                // [vol] range is 0 (silence) to 100 (max vol)

                osd_play_streamed_sample_16(channel, (signed short *)ym2151_buffer[0], buffer_size * 2, data_sample_rate, 20, -100);
                osd_play_streamed_sample_16(channel+1, (signed short *)ym2151_buffer[1], buffer_size * 2, data_sample_rate, 20, 100);
            
            cym_data_pos++;
        }

        // !0x00 // YM2151 // DATA WRITE //
        if (cym_data[cym_data_pos] != 0x00)
        {             
            cym_YM2151_register = cym_data[cym_data_pos];
            cym_data_pos++;
            cym_YM2151_value = cym_data[cym_data_pos];
            // YM2151WriteReg(int chip, int register, int value);
            YM2151WriteReg(0, cym_YM2151_register, cym_YM2151_value);
            cym_data_pos++;
        }
        
        // read key input from keyboard
        hitkey = kbhit();
        if (hitkey != 0)
            hitkey = 27;

        // looping if desired, reset data position and reset chip
        if (cym_data_pos >= cym_file_length && loopflag == 1)
        {
            cym_data_pos = 0;
            YM2151ResetChip(0);
        }
    }

    // shutdown eveything and exit
    YM2151Shutdown();
    msdos_shutdown_sound();
    exit(0);
}
